ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.15 by root, Fri Dec 10 21:15:06 2010 UTC vs.
Revision 1.40 by root, Sun May 1 07:56:26 2011 UTC

5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10
11# perl build variables 10# perl build variables
11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
13PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
16 17
17ARCH="$(uname -m)" 18ARCH="$(uname -m)"
18 19
19case "$ARCH" in 20case "$ARCH" in
27 ;; 28 ;;
28esac 29esac
29 30
30# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
31# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
32# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
33PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
34PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
35 37
36# some configuration options for modules 38# some configuration options for modules
37export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
38#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
39export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
40 44
41# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
42# required by mkbundle 46# required by mkbundle
43STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
44 48
45# which extra modules you might want to install 49# which extra modules you might want to install
46EXTRA_MODULES="" 50EXTRA_MODULES=""
47 51
48# overridable functions 52# overridable functions
49preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
50postconfigure() { : ; } 55postconfigure() { : ; }
51postbuild() { : ; } 56postbuild() { : ; }
52postinstall() { : ; } 57postinstall() { : ; }
53 58
54# now source user config, if any 59# now source user config, if any
61fi 66fi
62 67
63############################################################################# 68#############################################################################
64# support 69# support
65 70
66MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
67PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
68 72
69unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
70export LC_ALL=C # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
71 80
72# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
73VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
74$VERSION=0.91 83$VERSION="1.21"
75 84
76BZ2=bz2 85BZ2=bz2
77BZIP2=bzip2 86BZIP2=bzip2
78 87
79fatal() { 88fatal() {
125 134
126clean() { 135clean() {
127 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
128} 137}
129 138
139realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
143}
144
130fetch() { 145fetch() {
131 rcd "$STATICPERL" 146 rcd "$STATICPERL"
132 147
133 mkdir -p src 148 mkdir -p src
134 rcd src 149 rcd src
144perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
145trying $URL 160trying $URL
146EOF 161EOF
147 162
148 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
149 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
151 || fatal "$URL: unable to download" 166 || fatal "$URL: unable to download"
167 rm -f perl-$PERL_VERSION.tar.$BZ2
152 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
153 fi 169 fi
154 170
155 verblock <<EOF 171 verblock <<EOF
156unpacking perl 172unpacking perl
157EOF 173EOF
158 174
159 mkdir -p unpack 175 mkdir -p unpack
176 rm -rf unpack/perl-$PERL_VERSION
160 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
161 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
162 chmod -R u+w unpack/perl-$PERL_VERSION 179 chmod -R u+w unpack/perl-$PERL_VERSION
163 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
164 rmdir -p unpack 181 rmdir -p unpack
165 fi 182 fi
166} 183}
167 184
168# similar to GNU-sed -i or perl -pi 185# similar to GNU-sed -i or perl -pi
169sedreplace() { 186sedreplace() {
170 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 187 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
188 rm -f "$2"
171 mv "$2~" "$2" 189 mv "$2~" "$2"
190}
191
192configure_failure() {
193 cat <<EOF
194
195
196***
197*** Configure failed - see above for the exact error message(s).
198***
199*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
200*** flags are not supported by your compiler. Less often, this is because
201*** PERL_LIBS either contains a library not available on your system (such as
202*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
203***
204*** You can provide your own flags by creating a ~/.staticperlrc file with
205*** variable assignments. For example (these are the actual values used):
206***
207
208PERL_CC="$PERL_CC"
209PERL_CCFLAGS="$PERL_CCFLAGS"
210PERL_OPTIMIZE="$PERL_OPTIMIZE"
211PERL_LDFLAGS="$PERL_LDFLAGS"
212PERL_LIBS="$PERL_LIBS"
213
214EOF
215 exit 1
172} 216}
173 217
174configure() { 218configure() {
175 fetch 219 fetch
176 220
182configuring $STATICPERL/src/perl-$PERL_VERSION 226configuring $STATICPERL/src/perl-$PERL_VERSION
183EOF 227EOF
184 228
185 rm -f "$PERL_PREFIX/staticstamp.install" 229 rm -f "$PERL_PREFIX/staticstamp.install"
186 230
187 make distclean >/dev/null 2>&1 231 "$MAKE" distclean >/dev/null 2>&1
188 232
233 sedreplace '/^#define SITELIB/d' config_h.SH
234
189 # I hate them 235 # I hate them for this
190 grep -q -- -fstack-protector Configure && \ 236 grep -q -- -fstack-protector Configure && \
191 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
192 238
193 preconfigure 239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
194 244
195# trace configure \ 245# trace configure \
196 sh Configure -Duselargefiles \ 246 sh Configure -Duselargefiles \
197 -Uuse64bitint \ 247 -Uuse64bitint \
198 -Dusemymalloc=n \ 248 -Dusemymalloc=n \
199 -Uusedl \ 249 -Uusedl \
200 -Uusethreads \ 250 -Uusethreads \
201 -Uuseithreads \ 251 -Uuseithreads \
202 -Uusemultiplicity \ 252 -Uusemultiplicity \
203 -Duseperlio \
204 -Uusesfio \ 253 -Uusesfio \
205 -Uuseshrplib \ 254 -Uuseshrplib \
255 -Uinstallusrbinperl \
206 -Dcppflags="$PERL_CPPFLAGS" \ 256 -A ccflags=" $PERL_CCFLAGS" \
207 -Dccflags="-g2 -fno-strict-aliasing" \ 257 -Dcc="$PERL_CC" \
208 -Doptimize="$PERL_OPTIMIZE" \ 258 -Doptimize="$PERL_OPTIMIZE" \
209 -Dldflags="$PERL_LDFLAGS" \ 259 -Dldflags="$PERL_LDFLAGS" \
210 -Dlibs="$PERL_LIBS" \ 260 -Dlibs="$PERL_LIBS" \
211 -Dprefix="$PERL_PREFIX" \ 261 -Dprefix="$PERL_PREFIX" \
212 -Dbin="$PERL_PREFIX/bin" \ 262 -Dbin="$PERL_PREFIX/bin" \
213 -Dprivlib="$PERL_PREFIX/lib" \ 263 -Dprivlib="$PERL_PREFIX/lib" \
214 -Darchlib="$PERL_PREFIX/lib" \ 264 -Darchlib="$PERL_PREFIX/lib" \
215 -Uusevendorprefix \ 265 -Uusevendorprefix \
216 -Dsitelib="$PERL_PREFIX/lib" \ 266 -Dsitelib="$PERL_PREFIX/lib" \
217 -Dsitearch="$PERL_PREFIX/lib" \ 267 -Dsitearch="$PERL_PREFIX/lib" \
218 -Usitelibexp \
219 -Uman1dir \ 268 -Uman1dir \
220 -Uman3dir \ 269 -Uman3dir \
221 -Usiteman1dir \ 270 -Usiteman1dir \
222 -Usiteman3dir \ 271 -Usiteman3dir \
223 -Dpager=/usr/bin/less \ 272 -Dpager=/usr/bin/less \
224 -Demail="$EMAIL" \ 273 -Demail="$EMAIL" \
225 -Dcf_email="$EMAIL" \ 274 -Dcf_email="$EMAIL" \
226 -Dcf_by="$EMAIL" \ 275 -Dcf_by="$EMAIL" \
227 $PERL_CONFIGURE \ 276 $PERL_CONFIGURE \
277 -Duseperlio \
228 -dE || fatal "Configure failed" 278 -dE || configure_failure
229 279
230 sedreplace ' 280 sedreplace '
231 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
232 s/ *-fno-stack-protector */ /g 282 s/ *-fno-stack-protector */ /g
233 ' config.sh 283 ' config.sh
234 284
285 patchconfig || fatal "patchconfig hook failed"
286
235 sh Configure -S || fatal "Configure -S failed" 287 sh Configure -S || fatal "Configure -S failed"
236 288
237 postconfigure || fatal "postconfigure hook failed" 289 postconfigure || fatal "postconfigure hook failed"
238 290
239 touch staticstamp.configure 291 touch staticstamp.configure
292}
293
294write_shellscript() {
295 {
296 echo "#!/bin/sh"
297 echo "STATICPERL=\"$STATICPERL\""
298 echo "PERL_PREFIX=\"$PERL_PREFIX\""
299 echo "MAKE=\"$MAKE\""
300 cat
301 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1"
240} 303}
241 304
242build() { 305build() {
243 configure 306 configure
244 307
248building $STATICPERL/src/perl-$PERL_VERSION 311building $STATICPERL/src/perl-$PERL_VERSION
249EOF 312EOF
250 313
251 rm -f "$PERL_PREFIX/staticstamp.install" 314 rm -f "$PERL_PREFIX/staticstamp.install"
252 315
253 make || fatal "make: error while building perl" 316 "$MAKE" || fatal "make: error while building perl"
254 317
255 postbuild || fatal "postbuild hook failed" 318 postbuild || fatal "postbuild hook failed"
256} 319}
257 320
258install() { 321install() {
265EOF 328EOF
266 329
267 ln -sf "perl/bin/" "$STATICPERL/bin" 330 ln -sf "perl/bin/" "$STATICPERL/bin"
268 ln -sf "perl/lib/" "$STATICPERL/lib" 331 ln -sf "perl/lib/" "$STATICPERL/lib"
269 332
333 mkdir "$STATICPERL/patched"
334
270 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
271 rm -rf "$PERL_PREFIX" # by this rm -rf 336 rm -rf "$PERL_PREFIX" # by this rm -rf
272 337
273 make install || fatal "make install: error while installing" 338 "$MAKE" install || fatal "make install: error while installing"
274 339
275 rcd "$PERL_PREFIX" 340 rcd "$PERL_PREFIX"
276 341
277 # create a "make install" replacement for CPAN 342 # create a "make install" replacement for CPAN
278 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 343 write_shellscript SP-make-install-make <<'EOF'
279make || exit 344#CAT make-install-make.sh
280
281if find blib/arch/auto -type f | grep -q -v .exists; then
282 echo Probably an XS module, rebuilding perl
283 if make perl; then
284 mv perl "$PERL_PREFIX"/bin/perl
285 make -f Makefile.aperl map_clean
286 else
287 make -f Makefile.aperl map_clean
288 exit 1
289 fi
290fi
291
292make install UNINST=1
293EOF 345EOF
294 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
295 346
347 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF'
349#CAT patch-postinstall.sh
350EOF
351
352 "$PERL_PREFIX/bin/SP-patch-postinstall"
353
296 # trick CPAN into avoiding ~/.cpan completely 354 # help to trick CPAN into avoiding ~/.cpan completely
297 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
298 356
357 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway,
359 # so consider it "for good measure".
299 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
300 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
301 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
302 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
303 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
304 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
305 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
306 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
307 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
308 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
309 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
310 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
311 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
312 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
313 375
314 touch "$PERL_PREFIX/staticstamp.install" 376 touch "$PERL_PREFIX/staticstamp.install"
315 fi 377 fi
335installing modules from CPAN 397installing modules from CPAN
336$@ 398$@
337EOF 399EOF
338 400
339 for mod in "$@"; do 401 for mod in "$@"; do
340 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
341 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
342 done 404 done
343 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
344} 406}
345 407
357 for mod in "$@"; do 419 for mod in "$@"; do
358 echo 420 echo
359 echo $mod 421 echo $mod
360 ( 422 (
361 rcd $mod 423 rcd $mod
362 make -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
363 make distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
364 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
365 make || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
366 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
367 make distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
368 exit 0 430 exit 0
369 ) || exit $? 431 ) || exit $?
370 done 432 done
371} 433}
372 434
373############################################################################# 435#############################################################################
374# main 436# main
375 437
376podusage() { 438podusage() {
377 echo 439 echo
440
378 if [ -e "$PERL_PREFIX/bin/perl" ]; then 441 if [ -e "$PERL_PREFIX/bin/perl" ]; then
379 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 442 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
380 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 443 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
381 2>/dev/null && exit 444 2>/dev/null && exit
382 fi 445 fi
446
383 # try whatever perl we can find 447 # try whatever perl we can find
384 perl -MPod::Usage -e \ 448 perl -MPod::Usage -e \
385 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 449 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
386 2>/dev/null && exit 450 2>/dev/null && exit
387 451
388 fatal "displaying documentation requires a working perl - try '$0 install' first" 452 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
389} 453}
390 454
391usage() { 455usage() {
392 podusage 0 456 podusage 0
393} 457}
401#CAT mkbundle 465#CAT mkbundle
402MKBUNDLE 466MKBUNDLE
403} 467}
404 468
405bundle() { 469bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
406 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
407 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 472 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
408 CACHE="$STATICPERL/cache" 473 CACHE="$STATICPERL/cache"
409 mkdir -p "$CACHE" 474 mkdir -p "$CACHE"
410 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 475 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
418 command="${1#--}"; shift 483 command="${1#--}"; shift
419 case "$command" in 484 case "$command" in
420 version ) 485 version )
421 echo "staticperl version $VERSION" 486 echo "staticperl version $VERSION"
422 ;; 487 ;;
423 fetch | configure | build | install | clean | distclean) 488 fetch | configure | build | install | clean | realclean | distclean)
424 ( "$command" ) 489 ( "$command" ) || exit
425 ;; 490 ;;
426 instsrc ) 491 instsrc )
427 ( instsrc "$@" ) 492 ( instsrc "$@" ) || exit
428 exit 493 exit
429 ;; 494 ;;
430 instcpan ) 495 instcpan )
431 ( instcpan "$@" ) 496 ( instcpan "$@" ) || exit
497 exit
498 ;;
499 perl )
500 ( install ) || exit
501 exec "$PERL_PREFIX/bin/perl" "$@"
432 exit 502 exit
433 ;; 503 ;;
434 cpan ) 504 cpan )
435 ( install ) 505 ( install ) || exit
436 "$PERL_PREFIX/bin/cpan" "$@" 506 exec "$PERL_PREFIX/bin/cpan" "$@"
437 exit 507 exit
438 ;; 508 ;;
439 mkbundle ) 509 mkbundle )
440 ( install ) 510 ( install ) || exit
441 bundle "$@" 511 bundle "$@"
442 exit 512 exit
443 ;; 513 ;;
444 mkperl ) 514 mkperl )
445 ( install ) 515 ( install ) || exit
446 bundle --perl "$@" 516 bundle --perl "$@"
447 exit 517 exit
448 ;; 518 ;;
449 mkapp ) 519 mkapp )
450 ( install ) 520 ( install ) || exit
451 bundle --app "$@" 521 bundle --app "$@"
452 exit 522 exit
453 ;; 523 ;;
454 help ) 524 help )
455 podusage 2 525 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines